src/main/java/com/java3/myjavanotes/models/Note.java
package com.java3.myjavanotes.models;

import java.time.LocalDate;

/**
 * Defines the Note
 *
 * @author Cyrill Näf
 */
public class Note {
    private Integer id;
    private LocalDate date;
    private String title;
    private String note;
    private Boolean isNull = false;

    /**
     * Note without ID
     *
     * @param date  Note Date
     * @param title Note Title
     * @param note  Note Content, the actual note
     */
    public Note(LocalDate date, String title, String note) {
        this.id = null;
        this.date = date;
        this.title = title;
        this.note = note;
    }

    /**
     * Note with ID
     *
     * @param id    Note identifier
     * @param date  Note Date
     * @param title Note Title
     * @param note  Note Content, the actual note
     */
    public Note(Integer id, LocalDate date, String title, String note) {
        this.id = id;
        this.date = date;
        this.title = title;
        this.note = note;
    }

    /**
     * Empty Note
     */
    public Note() {
        this.isNull = true;
    }

    public Boolean isNull() {
        return isNull;
    }

    public Integer getId() {
        return id;
    }

    public LocalDate getDate() {
        return date;
    }

    public void setDate(LocalDate date) {
        this.date = date;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }
}

src/main/java/com/java3/myjavanotes/models/NoteDatastore.java
package com.java3.myjavanotes.models;

import java.util.List;

/**
 * Interface describing how the Note Datastore
 *
 * @author Cyrill Näf
 */
public interface NoteDatastore {
    /**
     * Get's a specific note from the datastore
     *
     * @param id ID of the note
     * @return The note as Note object
     */
    public Note getNote(int id);

    /**
     * Creates a new note in the datastore
     *
     * @param note The Note object
     */
    public void createNote(Note note);

    /**
     * Deletes a note in the datastore
     *
     * @param note The Note object (ID field is mandatory!)
     */
    public void deleteNote(Note note);

    /**
     * Deletes a note in the datastore
     *
     * @param id The id of a note
     */
    public void deleteNote(int id);

    /**
     * Returns a List of all notes objects in the datastore
     *
     * @return List of Notes object
     */
    public List<Note> getNotes();

    /**
     * Updates a note object
     *
     * @param note The Note object (ID field is mandatory!)
     * @return Returns the updated Note object
     */
    public Note updateNote(Note note);
}

src/main/java/com/java3/myjavanotes/controllers/FileBean.java
package com.java3.myjavanotes.controllers;

import com.java3.myjavanotes.models.JDBCNote;
import com.java3.myjavanotes.models.Note;
import com.java3.myjavanotes.models.NoteDatastore;
import jakarta.faces.context.FacesContext;
import jakarta.servlet.ServletOutputStream;
import jakarta.servlet.http.HttpServletResponse;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import jakarta.servlet.http.Part;
import org.w3c.dom.*;

import java.io.InputStream;
import java.io.StringWriter;
import java.time.LocalDate;
import java.util.List;

/**
 * Responsible for Exporting/Importing notes via XML. Implements the Note Datastore interface
 *
 * @author Cyrill Näf
 * @see com.java3.myjavanotes.models.Note
 * @see com.java3.myjavanotes.models.JDBCNote
 */
public class FileBean {
    private NoteDatastore db = new JDBCNote();
    private Part uploadedFile;

    public Part getUploadedFile() {
        return uploadedFile;
    }

    public void setUploadedFile(Part uploadedFile) {
        this.uploadedFile = uploadedFile;
    }

    /**
     * Downloads a xml file containing all notes from the database
     */
    public void download() {
        String xml = this.generateXML();
        HttpServletResponse response = (HttpServletResponse) FacesContext.getCurrentInstance().getExternalContext().getResponse();
        response.setContentType("text/xml");
        response.setHeader("Content-Disposition", "attachment;filename=file.xml");
        try {
            ServletOutputStream out = response.getOutputStream();
            out.write(xml.getBytes());
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Processes the uploaded xml file
     */
    public void upload() {
        try {
            this.parseXML();
        } catch (Exception e) {
            // We return a error if the xml import throws any exception
            HttpServletResponse response = (HttpServletResponse) FacesContext.getCurrentInstance().getExternalContext().getResponse();
            response.setStatus(500);
        }
    }

    /**
     * Parses the xml file
     *
     * @throws Exception Return any exception back to the caller. Caller should handle together with frontend
     */
    protected void parseXML() throws Exception {
        // XML Helpers....
        DocumentBuilderFactory documentFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder documentBuilder = documentFactory.newDocumentBuilder();
        InputStream inputStream = getUploadedFile().getInputStream();
        Document document = documentBuilder.parse(inputStream);
        // Document document = documentBuilder.parse(getUploadedFile().getInputStream());

        // Get root element
        document.getDocumentElement().normalize();

        // Get all childs of type note
        NodeList nodeList = document.getElementsByTagName("note");

        // Iterate over our childs
        for (int counter = 0; counter < nodeList.getLength(); counter++) {
            Node nNode = nodeList.item(counter);
            if (nNode.getNodeType() == Node.ELEMENT_NODE) {
                Element eElement = (Element) nNode;
                Integer id = null;
                try {
                    id = Integer.parseInt(eElement.getAttribute("id"));
                } catch (NumberFormatException e) {
                    id = null;
                }
                String title = eElement.getElementsByTagName("title").item(0).getTextContent();
                LocalDate date = LocalDate.parse(eElement.getElementsByTagName("date").item(0).getTextContent());
                String note = eElement.getElementsByTagName("text").item(0).getTextContent();
                // Generate Note object from xml
                Note newNote = new Note(id, date, title, note);
                // Do update logic
                // We do not care about already existing elements
                if (id == null || db.getNote(newNote.getId()).isNull()) {
                    db.createNote(newNote);
                } else {
                    // Here we assume that the object with that ID already exists, so we update it
                    db.updateNote(newNote);
                }
            }
        }

    }

    /**
     * Magic, generates the xml as string
     *
     * @return XML String
     */
    protected String generateXML() {
        try {
            // Get all notes
            List<Note> notes = db.getNotes();
            // XML Helpers....
            DocumentBuilderFactory documentFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder documentBuilder = documentFactory.newDocumentBuilder();
            Document document = documentBuilder.newDocument();

            // root element - notes
            Element root = document.createElement("notes");
            document.appendChild(root);

            // add all note's
            for (Note note : notes) {
                // note element
                Element element = document.createElement("note");
                root.appendChild(element);

                // set an attribute to note element
                Attr attr = document.createAttribute("id");
                attr.setValue(Integer.toString(note.getId()));
                element.setAttributeNode(attr);


                // title element
                Element title = document.createElement("title");
                title.appendChild(document.createTextNode(note.getTitle()));
                element.appendChild(title);

                // date element
                Element date = document.createElement("date");
                date.appendChild(document.createTextNode(note.getDate().toString()));
                element.appendChild(date);

                // note element
                Element noteE = document.createElement("text");
                noteE.appendChild(document.createTextNode(note.getNote()));
                element.appendChild(noteE);
            }
            // Transform Document to XML String
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            StringWriter writer = new StringWriter();
            transformer.transform(new DOMSource(document), new StreamResult(writer));

            // If you use
            // StreamResult result = new StreamResult(System.out);
            // the output will be pushed to the standard output ...
            // You can use that for debugging
            return writer.toString();

        } catch (ParserConfigurationException | TransformerException pce) {
            pce.printStackTrace();
        }
        return "";
    }
}

src/main/java/com/java3/myjavanotes/controllers/NoteBean.java
package com.java3.myjavanotes.controllers;

import com.java3.myjavanotes.models.*;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeFormatterBuilder;
import java.util.Date;

/**
 * <h1>Note Bean</h1>
 *
 * <ul>Controller for the xHtml Pages detailedNote.xhtml or listOfNotes.xhtml</ul>
 * <ul>Different Methods are called from the xhtml pages and this call contains the Logic.</ul>
 *
 * @author Oliver Huber
 * @see com.java3.myjavanotes.models.JDBCNote
 * @see com.java3.myjavanotes.models.Note
 */

public class NoteBean {
    //Initialize Objects
    String pattern = "dd.MM.yyyy";
    DateFormat df = new SimpleDateFormat(pattern);
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern(pattern);
    DateFormat dfcurrent;
    Note note = new Note();
    JDBCNote jdbcNote = new JDBCNote();

    //Initialize Variables
    private Long noteId;
    private String siteTitle;
    private String backButton;
    private LocalDate date;
    private String dateText;
    private String title;
    private String Notiz;
    boolean onlyView;

    /**
     * Creates or Updates the Note after user pressed the button
     *
     * @return ListOfNotes.xml as a String
     * @throws ParseException If Date pattern is wrong
     */
    public String save() throws ParseException {
        //Fill the Note Object
        note.setNote(Notiz);
        note.setTitle(title);
        date = LocalDate.parse(dateText, formatter);
        note.setDate(date);
        //Sending Note Object to the Correct Method
        if (siteTitle.contains("erfassen")) {
            jdbcNote.createNote(note);
        } else {
            jdbcNote.updateNote(note);
        }
        //Redirecting back to the Home Screen
        return "listOfNotes.xhtml?faces-redirect=true";
    }

    /**
     * Setup detailed Note Site for creating notes
     *
     * @return detailedNote.xhtml String
     */
    public String create() {
        //Clearing Variables for Creating a new Note
        dateText = "";
        title = "";
        Notiz = "";
        //Setting Title and Button name for the site
        siteTitle = "Notiz erfassen";
        backButton = "Create";
        onlyView = false;
        //Redirect to detailedNote.xhtml
        return "detailedNote.xhtml?faces-redirect=true";
    }

    /**
     * Deleting a selected note in the note table. Uses Row Note Id as Parameter
     *
     * @return listOfNotes.xhtml
     */
    public String delete() {
        //Deleting Note with the NoteId
        try {
            jdbcNote.deleteNote(noteId.intValue());
        } catch (NullPointerException p) {
            p.printStackTrace();
        }
        //Redirecting back to home
        return "listOfNotes.xhtml?faces-redirect=true";
    }

    /**
     * Setup detailed Note Site for editing Note
     *
     * @return detailedNote.xhtml
     */
    public String edit() {
        //Filling note with note data from DB
        fillNote();
        //Setting Title and Button name for the site
        siteTitle = "Notiz editieren";
        backButton = "Update";
        onlyView = false;
        //Redirect to detailedNote.xhtml
        return "detailedNote.xhtml?faces-redirect=true";

    }

    /**
     * Setup detailed Note Site for viewing Note
     *
     * @return detailedNote.xhtml
     */
    public String view() {
        //Filling note with note data from DB
        fillNote();
        //Setting Title and Button name for the site
        siteTitle = "Notiz anzeigen";
        onlyView = true;
        //Redirect to detailedNote.xhtml
        return "detailedNote.xhtml?faces-redirect=true";
    }

    /**
     * Filling Note Values of Bean for detailed xHtml
     */
    public void fillNote() {
        //Getting note from the database
        try {
            note = jdbcNote.getNote(noteId.intValue());
        } catch (NullPointerException p) {
            p.printStackTrace();
        }
        //Setting Variables used in xHtml Site
        dateText = note.getDate().format(formatter);
        title = note.getTitle();
        Notiz = note.getNote();
    }

    /**
     * Returning Date in specific Format for xHtml
     *
     * @return Current Date as dd.MM.yyyy HH:mm:ss
     */
    public String getCurrentDate() {
        //Setting up a date Pattern
        dfcurrent = new SimpleDateFormat("yyy-MM-dd HH:mm:ss");
        return dfcurrent.format(new Date());
    }
    /*
    GETTER AND SETTER
     */

    public void setSiteTitle(String siteTitle) {
        this.siteTitle = siteTitle;
    }
    public String getSiteTitle() {
        return siteTitle;
    }

    public String getTitle() {
        return title;
    }

    public String getDateText() {
        return dateText;
    }

    public void setDateText(String dateText) {
        this.dateText = dateText;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getNotiz() {
        return Notiz;
    }

    public void setNotiz(String notiz) {
        Notiz = notiz;
    }

    public boolean isOnlyView() {
        return onlyView;
    }

    public void setOnlyView(boolean onlyView) {
        this.onlyView = onlyView;
    }

    public Long getNoteId() {
        return noteId;
    }

    public void setNoteId(Long noteId) {
        this.noteId = noteId;
    }

    public String getBackButton() {
        return backButton;
    }

}

src/main/webapp/detailedNote.xhtml
<!--Shows the detailed page of the note
Author: Oliver Huber
-->
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      lang="de">
<head>
    <meta charset="utf-8" content="utf-8"/>
    <title>My Java Notes</title>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css"></link>
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet"></link>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <style>
        body {
            display: flex;
            min-height: 100vh;
            flex-direction: column;
        }

        main {
            flex: 1 0 auto;
        }
    </style>
</head>

<body>
<header>
    <h:form style="margin-bottom: 0px;">
        <!-- Dropdown Structure -->
        <ul id="options" class="dropdown-content">
            <li><h:commandLink class="modal-trigger" action="#{file.download}">
                <h:outputText class="modal-trigger" value="Export"></h:outputText>
            </h:commandLink></li>
            <li><!-- Import Modal Trigger -->
                <a class="modal-trigger" href="#import-modal">Import</a>
            </li>
        </ul>
    </h:form>

    <!-- Refresh Button -->
    <div class="navbar-fixed">
        <nav>
            <div class="nav-wrapper">
                <a href="listOfNotes.xhtml" class="brand-logo center">My Notes</a>
                <ul class="right hide-on-med-and-down">
                    <!-- Dropdown Trigger -->
                    <li><a class="dropdown-trigger" href="#!" data-target="options"><i
                            class="material-icons">more_vert</i></a>
                    </li>
                </ul>
            </div>
        </nav>
    </div>
</header>
<main>
    <div class="container">
        <!-- Import Modal -->
        <div id="import-modal" class="modal">
            <h:form id="import" enctype="multipart/form-data">
                <div class="modal-content">
                    <div class="file-field input-field">
                        <div class="btn">
                            <span>File</span>
                            <h:inputFile id="file" value="#{file.uploadedFile}"
                                         required="true"
                                         requiredMessage="Please upload a file" alt="upload file"></h:inputFile>
                        </div>

                        <div class="file-path-wrapper">
                            <input class="file-path validate" type="text"/>
                        </div>

                    </div>
                </div>
                <div class="modal-footer">
                    <h:commandButton class="btn" id="submit-button" value="Upload"
                                     action="#{file.upload}"></h:commandButton>

                </div>
            </h:form>
        </div>
        <h2>
            <h:outputText value="#{noteControl.siteTitle}"/>
        </h2>

        <!-- Data Display -->
        <h:form id="note" class="col s12">
            <div class="row">

                <!-- Date Input -->
                <div class="input-field col s12">
                    <i class="material-icons prefix">date_range</i>
                    <h:inputText class="datepicker" id="date" value="#{noteControl.dateText}"
                                 autocomplete="off" disabled="#{noteControl.onlyView}" required="true"
                                 requiredMessage="Datum auswählen!">
                        <f:validateRequired/>
                    </h:inputText>
                    <h:message for="date" style="color:red"></h:message>
                </div>

                <!-- Title Input -->
                <div class="input-field col s12">
                    <h:outputLabel for="title">Title</h:outputLabel>
                    <h:inputText class="validate" id="title" value="#{noteControl.title}"
                                 autocomplete="off" readonly="#{noteControl.onlyView}" required="true"
                                 validatorMessage="Fehlerhafte Eingabe! Nur 150 Zeichen oder folgende Sonderzeichen !?'+.,:-_ erlaubt" requiredMessage="Titel eingeben!">
                        <f:validateRequired/>
                        <f:validateRegex pattern="[\r\na-zA-Z0-9 .,:-_äöü!?'+]+"/>
                        <f:validateLength maximum="150"/>
                    </h:inputText>
                    <h:message for="title" style="color:red"></h:message>
                </div>

                <!-- Notiz Input -->
                <div class="input-field col s12">
                    <h:outputLabel for="notiz">Notiz</h:outputLabel>
                    <h:inputTextarea class="materialize-textarea" id="notiz" validatorMessage="Fehlerhafte Eingabe! Nur 5000 Zeichen oder folgende Sonderzeichen !?'+.,:-_ erlaubt"
                                     readonly="#{noteControl.onlyView}" value="#{noteControl.notiz}" required="false">
                        <f:validateRegex pattern="[\r\na-zA-Z0-9 .,:-_äöü!?'+]+|^$"/>
                        <f:validateLength maximum="5000"/>
                    </h:inputTextarea>
                    <h:message for="notiz" style="color:red"></h:message>
                </div>

                <!-- Navigation Buttons -->
                <div class="input-field col s12">
                    <h:commandButton class="btn-large red" id="abort-button" rendered="#{noteControl.onlyView eq false}"
                                     immediate="true" value="Cancel" action="/listOfNotes.xhtml?faces-redirect=true">
                    </h:commandButton>
                    <h:commandButton class="btn-large red" id="create-button"
                                     rendered="#{noteControl.onlyView eq false}" value="#{noteControl.backButton}"
                                     action="#{noteControl.save}">
                    </h:commandButton>
                    <h:commandButton class="btn-large red" id="back-button" rendered="#{noteControl.onlyView}"
                                     value="Back" immediate="true" action="/listOfNotes.xhtml?faces-redirect=true">
                    </h:commandButton>
                </div>
            </div>
        </h:form>
    </div>
</main>

<!-- Footer -->
<footer class="page-footer">
    <div class="footer-copyright">
        <div class="container">
            © 2021 Cyrill Näf, Oliver Huber &amp; Dane Singer
            <a class="grey-text text-lighten-4 right"
               href="https://gitlab.com/biggold/hf-it-hbu/myjavanotes">Source Code</a>
        </div>
    </div>
</footer>

<!-- Compiled and minified JavaScript -->
<!--JavaScript at end of body for optimized loading-->
<script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"
        type="application/javascript"></script>
<script src="https://code.jquery.com/jquery-2.1.1.min.js" type="application/javascript"></script>
<script>
    document.addEventListener('DOMContentLoaded', function () {
        var elems = document.querySelectorAll('.dropdown-trigger');
        var instances = M.Dropdown.init(elems, options);
    });
    document.addEventListener('DOMContentLoaded', function () {
        var elems = document.querySelectorAll('.modal');
        var instances = M.Modal.init(elems, options);
    });
    document.addEventListener('DOMContentLoaded', function () {
        var options = {
            format: 'dd.mm.yyyy'
        };
        var elems = document.querySelectorAll('.datepicker');
        var instances = M.Datepicker.init(elems, options);
    });

</script>
</body>
</html>

src/main/webapp/index.jsp
<%@ page contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<!DOCTYPE html>
<html>
<head>
    <title>JSP - Hello World</title>
</head>
<body>
<h1><%= "Hello World!" %>
</h1>
<br/>
<a href="hello-servlet">Hello Servlet</a>
</body>
</html>

src/main/webapp/listOfNotes.xhtml
<!--Lists the Notes in a table
Author: Oliver Huber
-->
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      lang="de">
<head>
    <meta charset="utf-8" content="utf-8"/>
    <title>My Java Notes</title>
    <!-- Compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css"></link>
    <!--Import Google Icon Font-->
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet"></link>
    <!--Let browser know website is optimized for mobile-->
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <style>
        body {
            display: flex;
            min-height: 100vh;
            flex-direction: column;
        }

        main {
            flex: 1 0 auto;
        }
    </style>
</head>

<body>
<header>
    <h:form style="margin-bottom: 0px;">
        <!-- Dropdown Structure -->
        <ul id="options" class="dropdown-content">
            <li><h:commandLink class="modal-trigger" action="#{file.download}">
                <h:outputText class="modal-trigger" value="Export"></h:outputText>
            </h:commandLink></li>
            <li><!-- Import Modal Trigger -->
                <a class="modal-trigger" href="#import-modal">Import</a>
            </li>
        </ul>
    </h:form>
    <div class="navbar-fixed">
        <nav>

            <!-- Refresh Button -->
            <div class="nav-wrapper">
                <a href="listOfNotes.xhtml" class="brand-logo center">My Notes</a>
                <ul class="right hide-on-med-and-down">
                    <li><a href="javascript:history.go(0)"><i
                            class="material-icons right">refresh</i>#{noteControl.currentDate}</a></li>
                    <!-- Dropdown Trigger -->
                    <li><a class="dropdown-trigger" href="#!" data-target="options"><i
                            class="material-icons">more_vert</i></a>
                    </li>
                </ul>
            </div>
        </nav>
    </div>

</header>
<main>
    <div class="container">
        <!-- Page Content goes here -->
        <!-- Add button -->
        <div class="fixed-action-btn">
            <h:form>
                <h:commandLink class="btn-floating btn-large red" id="image-link-id" action="#{noteControl.create}">
                    <i class='large material-icons'>add</i>
                </h:commandLink>
            </h:form>
        </div>


        <!-- Import Modal -->
        <div id="import-modal" class="modal">
            <h:form id="import" enctype="multipart/form-data">
                <div class="modal-content">
                    <div class="file-field input-field">
                        <div class="btn">
                            <span>File</span>
                            <h:inputFile id="file" value="#{file.uploadedFile}"
                                         required="true"
                                         requiredMessage="Please upload a file" alt="upload file"></h:inputFile>
                        </div>

                        <div class="file-path-wrapper">
                            <input class="file-path validate" type="text"/>
                        </div>

                    </div>
                </div>
                <div class="modal-footer">
                    <h:commandButton class="btn" id="submit-button" value="Upload"
                                     action="#{file.upload}"></h:commandButton>

                </div>
            </h:form>
        </div>

        <!-- Notes Table -->
        <h:dataTable value="#{note.notes}" var="p">
            <h:column>
                <f:facet name="header">Nr</f:facet>
                <h:outputText value="#{p.id}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Datum</f:facet>
                <h:outputText value="#{p.date}">

                </h:outputText>
            </h:column>
            <h:column>
                <f:facet name="header">Title</f:facet>
                <h:outputText value="#{p.title}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Aktionen</f:facet>

                <!-- All Buttons -->
                <h:form id="action">
                    <h:commandButton class="btn-flat material-icons" id="details-button" value="visibility"
                                     action="#{noteControl.view}">
                        <f:setPropertyActionListener target="#{noteControl.noteId}" value="#{p.id}"/>
                    </h:commandButton>
                    <h:commandButton class="btn-flat material-icons" id="edit-button" value="edit"
                                     action="#{noteControl.edit}">
                        <f:setPropertyActionListener target="#{noteControl.noteId}" value="#{p.id}"/>
                    </h:commandButton>
                    <h:commandButton class="btn-flat material-icons"
                                     onclick="if (! confirm('Soll Notiz wirklich gelöscht werden?')) return false"
                                     id="delete-button" value="delete"
                                     action="#{noteControl.delete}">
                        <f:setPropertyActionListener target="#{noteControl.noteId}" value="#{p.id}"/>
                    </h:commandButton>
                </h:form>
            </h:column>
        </h:dataTable>
    </div>
</main>
<!-- Footer -->
<footer class="page-footer">
    <div class="footer-copyright">
        <div class="container">
            © 2021 Cyrill Näf, Oliver Huber &amp; Dane Singer
            <a class="grey-text text-lighten-4 right"
               href="https://gitlab.com/biggold/hf-it-hbu/myjavanotes">Source Code</a>
        </div>
    </div>
</footer>

<!-- Compiled and minified JavaScript -->
<!--JavaScript at end of body for optimized loading-->
<script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"
        type="application/javascript"></script>
<script src="https://code.jquery.com/jquery-2.1.1.min.js" type="application/javascript"></script>
<script>
    document.addEventListener('DOMContentLoaded', function () {
        var elems = document.querySelectorAll('.dropdown-trigger');
        var instances = M.Dropdown.init(elems, options);
    });
    document.addEventListener('DOMContentLoaded', function () {
        var elems = document.querySelectorAll('.modal');
        var instances = M.Modal.init(elems, options);
    });

    function reloadFunction() {
        location.reload();
    }
</script>
</body>
</html>